workflows/test: factor out steps & refactoring

This commit is contained in:
Egor Tensin 2021-07-02 20:16:57 +03:00
parent 4785090c89
commit 3d49180b0b
6 changed files with 153 additions and 95 deletions

View file

@ -0,0 +1,20 @@
name: Build foo.exe
description: Build foo.exe (on Cygwin)
inputs:
platform:
description: Target platform
required: true
runs:
using: composite
steps:
- run: |
IFS= read -r src_dir <<'EOF'
${{ github.workspace }}
EOF
echo "$src_dir"
src_dir="$( cygpath -ua "$src_dir" )"
cd -- "$src_dir"
arch=
[ '${{ matrix.platform }}' == 'x86' ] && arch=-m32
clang++ $arch -std=c++14 -o foo.exe foo.cpp
shell: C:\tools\cygwin\bin\bash.exe --login --norc -eo pipefail -o igncr '{0}'

20
.github/actions/build-foo/action.yml vendored Normal file
View file

@ -0,0 +1,20 @@
name: Build foo.exe
description: Build foo.exe
inputs:
platform:
description: Target platform
required: true
runs:
using: composite
steps:
- run: |
$flags = @()
if ('${{ matrix.platform }}' -eq 'x86') {
$flags += '-m32'
}
$flags += '-std=c++14','-o','foo.exe','foo.cpp'
if ('${{ runner.os }}' -eq 'Linux') {
$flags += '-lpthread'
}
clang++ $flags
shell: pwsh

View file

@ -0,0 +1,25 @@
name: Check cc/c++
description: Check cc/c++ (on Cygwin)
runs:
using: composite
steps:
- run: |
check_tool() {
local exe
for exe; do
full_path="$( command -v "$exe" )"
echo "$full_path"
output="$( "$full_path" --version )"
echo "$output"
if ! echo "$output" | grep -F -- "clang version"; then
echo 'Unexpected `'"$exe"' --version` output.' >&2
exit 1
fi
done
}
check_tool cc
check_tool c++
shell: C:\tools\cygwin\bin\bash.exe --login --norc -eo pipefail -o igncr '{0}'

22
.github/actions/check-cc/action.yml vendored Normal file
View file

@ -0,0 +1,22 @@
name: Check cc/c++
description: Check cc/c++
runs:
using: composite
steps:
- run: |
function Check-Exe {
param(
[Parameter(Mandatory=$true)]
[string] $Exe
)
echo (Get-Command $Exe).Path
$output = & $Exe --version
echo $output
$($output | Select-String -Pattern "clang version" -SimpleMatch -Quiet) -or $(throw "Unexpected `$Exe --version` output")
}
Check-Exe cc
Check-Exe c++
shell: pwsh

26
.github/actions/run-foo/action.yml vendored Normal file
View file

@ -0,0 +1,26 @@
name: Run foo.exe
description: Run foo.exe and verify its output
runs:
using: composite
steps:
- run: |
$expected = @"
Doing something #1
Doing something #2
Doing something #3
"@
$actual = & (Join-Path . foo.exe)
$actual = $actual -join [Environment]::NewLine
echo @"
Expected output:
$expected
"@
echo @"
Actual output:
$actual
"@
$($actual -eq $expected) -or $(throw "Unexpected output!")
shell: pwsh

View file

@ -11,118 +11,63 @@ on:
jobs:
test:
strategy:
fail-fast: false
matrix:
platform: [x86, x64]
cygwin: [0, 1]
hardlinks: [0, 1]
os: [ubuntu-18.04, ubuntu-20.04, ubuntu-latest, windows-2016, windows-2019, windows-latest]
include:
# Prettier run names.
- {os: ubuntu-18.04, name: Ubuntu 18.04}
- {os: ubuntu-20.04, name: Ubuntu 20.04}
- {os: ubuntu-latest, name: Ubuntu (latest)}
- {os: windows-2016, name: Windows Server 2016}
- {os: windows-2019, name: Windows Server 2019}
- {os: windows-latest, name: Windows Server (latest)}
- {cygwin: 1, name: Cygwin}
exclude:
# No Cygwin on Ubuntu.
- {os: ubuntu-18.04, cygwin: 1}
- {os: ubuntu-20.04, cygwin: 1}
- {os: ubuntu-latest, cygwin: 1}
# Cygwin is the same on all Windows Server versions.
- {os: windows-2016, cygwin: 1}
- {os: windows-2019, cygwin: 1}
# Only test hardlinks on Cygwin.
- {cygwin: 0, hardlinks: 1}
runs-on: '${{ matrix.os }}'
name: '${{ matrix.name }} / ${{ matrix.platform }} / Hardlinks: ${{ matrix.hardlinks }}'
defaults:
run:
shell: pwsh
name: 'Test: ${{ matrix.os }} / ${{ matrix.platform }}'
steps:
- name: Checkout
uses: actions/checkout@v2
- name: Clean up PATH
uses: egor-tensin/cleanup-path@v1
if: runner.os == 'Windows'
- name: Install Cygwin
uses: egor-tensin/setup-cygwin@v3
with:
platform: '${{ matrix.platform }}'
if: matrix.cygwin
- name: Set up Clang
uses: ./
with:
platform: '${{ matrix.platform }}'
cygwin: '${{ matrix.cygwin }}'
cc: 1
- name: Build foo.exe
uses: ./.github/actions/build-foo
- name: Run foo.exe
uses: ./.github/actions/run-foo
- name: Check cc/c++
uses: ./.github/actions/check-cc
cygwin:
strategy:
matrix:
platform: [x86, x64]
hardlinks: [0, 1]
runs-on: windows-latest
name: 'Cygwin: ${{ matrix.platform }} / hardlinks${{ matrix.hardlinks }}'
steps:
- name: Checkout
uses: actions/checkout@v2
- name: Clean up PATH
uses: egor-tensin/cleanup-path@v1
- name: Install Cygwin
uses: egor-tensin/setup-cygwin@v3
with:
platform: '${{ matrix.platform }}'
- name: Set up Clang
uses: ./
with:
platform: '${{ matrix.platform }}'
cygwin: 1
cc: 1
hardlinks: '${{ matrix.hardlinks }}'
- name: Build foo.exe
run: |
$flags = @()
if ('${{ matrix.platform }}' -eq 'x86') {
$flags += '-m32'
}
$flags += '-std=c++14','-o','foo.exe','foo.cpp'
if ('${{ runner.os }}' -eq 'Linux') {
$flags += '-lpthread'
}
clang++ $flags
if: '!matrix.cygwin || matrix.hardlinks'
- name: Build foo.exe on Cygwin
run: |
$cwd = cygpath.exe -ua (Get-Location)
$arch = if ('${{ matrix.platform }}' -eq 'x64') { '-m64' } else { '-m32' }
$cmd = printf.exe -- 'cd %q && clang++ %q -std=c++14 -o foo.exe foo.cpp' $cwd $arch
bash.exe --login -o errexit -c $cmd
if: matrix.cygwin && !matrix.hardlinks
uses: ./.github/actions/build-foo
if: matrix.hardlinks
- name: Build foo.exe
uses: ./.github/actions/build-foo-cygwin
if: '!matrix.hardlinks'
- name: Run foo.exe
run: |
$expected = @"
Doing something #1
Doing something #2
Doing something #3
"@
$actual = & (Join-Path . foo.exe)
$actual = $actual -join [Environment]::NewLine
$($actual -eq $expected) -or $(throw @"
Unexpected output:
$actual
"@)
uses: ./.github/actions/run-foo
- name: Check cc/c++
run: |
echo (Get-Command cc).Path
$cc = & cc --version
echo $cc
$($cc | Select-String -Pattern "clang version" -SimpleMatch -Quiet) -or $(throw "Unexpected `cc --version` output")
echo (Get-Command c++).Path
$cxx = & c++ --version
echo $cxx
$($cxx | Select-String -Pattern "clang version" -SimpleMatch -Quiet) -or $(throw "Unexpected `c++ --version` output")
if: '!matrix.cygwin || matrix.hardlinks'
uses: ./.github/actions/check-cc
if: matrix.hardlinks
- name: Check cc/c++ on Cygwin
run: |
$cc = bash.exe --login -o errexit -c 'cc --version'
echo $cc
$($cc | Select-String -Pattern "clang version" -SimpleMatch -Quiet) -or $(throw "Unexpected `cc --version` output")
$cxx = bash.exe --login -o errexit -c 'c++ --version'
echo $cxx
$($cxx | Select-String -Pattern "clang version" -SimpleMatch -Quiet) -or $(throw "Unexpected `c++ --version` output")
if: matrix.cygwin && !matrix.hardlinks
uses: ./.github/actions/check-cc-cygwin
if: '!matrix.hardlinks'